#!/usr/bin/env python

"""
Python/GGI demo. This is a reimplementation of demo.c in
 libggi*/programs/demos/demo.c
 
 
"""

from ggi import *


# calls ggiInit()
g = ggi()
# calls ggiOpen(NULL)
v = g.Open()


_map = []
for i in range(0,256):
	# create_color behaves like a contructor for 
	# ggi_color, you can pass a (r,g,b,a), if not provided
	# it defales to all zeros 
	_map.append( create_color() )	
	
depth, doclip = 0,0

# get the mode
# have the visual object return a mode object
m = ggi_mode()
m.frames =  1 
# create_coord acts like a 
m.visible = create_coord(GGI_AUTO,GGI_AUTO) 
m.virt = create_coord(GGI_AUTO,GGI_AUTO) 
m.size = create_coord(0,0)
m.graphtype = GT_AUTO 
m.dpp = create_coord(GGI_AUTO,GGI_AUTO) 
v.SetMode( m )

        
type=0;
sx,sy,vy,vx=0,0,0,0
depth=GT_DEPTH(0)

sx_5 = sx/5
sx_12 = sx/12
sy_5 = sy/5
sy_12 = sy/12

if GT_SCHEME( m.graphtype ) == GT_PALETTE:
	v.SetColorfulPalette()
	_pal = v.GetPalette(0, 1<<depth)
	pal = []
	for (r,g,b,a) in _pal:
		pal.append( create_color(r,g,b,a) )
		
	
_map[0].r = 0xFFFF
_map[0].g = 0xFFFF
_map[0].b = 0xFFFF

v.Fillscreen()

import strop

def func(x):
	return chr( ord(x) + 1 )

j,i = 0,0
inc = 1

while 1:
	if i == 0:
		inc = 1
	if i == 255:
		inc= -1
	i = i + inc
	
	r = str(j) * 100000
	v.PutBox(10+i,10+i,100,100,r)
	j = j + 1
	j = j % 32767	

v.Getc()


